/* cl_main.c
 * ANDHILL98 (soccer client for Robocup-98)
 * Tomohito Andou <tandou@ccm.cl.nec.co.jp>
 * Copyright (C) 1998 Tomohito Andou
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "client.h"
#include "cl_nn.h"

void main(int argc, char **argv)
{
  char		*server;
  int		port;
  InitInfo	info;
  FILE		*fp;
  char		fname[20];
  int		i;
  int		posi_init_flag;
  int		reconnect_flag;
  int		goalie_flag;

  srandom(time(0));
  strcpy(game_team, "Andhill98");
  server 		= "localhost";
  port	 		= 6000;
  learn_flag		= 0;
  output_flag		= 0;
  test_flag		= 0;
  posi_init_flag	= 0;
  reconnect_flag	= 0;
  goalie_flag		= 0;
  for (i=1; i<argc; i++) {
    if (argv[i][0]!='-' && argv[i][0]!='/') continue;
    switch (argv[i][1]) {
     case 't':
      strcpy(game_team, argv[i+1]);	break;
     case 's':
      server = argv[i+1];		break;
     case 'p':
      port = atoi(argv[i+1]);		break;
     case 'f':
      learn_flag |= 2;			break;
     case 'l':
      learn_flag |= 1;			break;
     case 'L':
      learn_flag |= 5;			break;
     case 'i':
      posi_init_flag = 1;		break;
     case 'z':
      posi_init_flag = 2;		break;
     case 'o':
      output_flag = atoi(argv[i+1]);	break;
     case 'r':
      reconnect_flag = atoi(argv[i+1]);	break;
     case 'g':
      goalie_flag = 1;			break;
     default:
      fprintf(stderr, "Usage: %s [-t TEAMNAME] [-s SERVERHOST] [-p PORT] [-f] [-l | -L] [-i] [-o OLEV] [-r UNUM]\n", argv[0]);
      exit(1);
    }
  }

  sock = init_connection(server,port);

  if (sock.socketfd == -1)
    exit(1);

  if (reconnect_flag) {
    info = send_com_reconnect(&sock, game_team, reconnect_flag);
    info.unum = reconnect_flag;
  } else
    info = send_com_init(&sock, game_team, goalie_flag);

#if 0
  printf("\ninit!: %d, %d, %s, %d\n\n",
	 info.side, info.unum, info.playmodestr, info.playmode);
#endif
  usleep(WAIT_TIME);

  if ((learn_flag & 3) != 2) {
    if (posi_init_flag == 1)
      posi_rand_init(0);
    else if (posi_init_flag == 2)
      posi_rand_init(1);
    else {
      sprintf(fname, "%s%02d.pos", game_team, info.unum);
	if ((fp = fopen(fname, "r")) == NULL) {
	  fprintf(stderr, "%s: initialized by zero.\n", fname);
	  /* exit(1); */
	  posi_rand_init(1);
	} else {
	  posi_input(fp);
	  fclose(fp);
	}
    }
  }

  initialize();

  game_time	= 0;
  game_side	= info.side;
  my_unum	= game_unum	= info.unum;
  get_mode(info.playmodestr);
  game_my_score	= 0;
  game_op_score	= 0;

  if (info.side == S_UNKNOWN) {
    printf("Can't init\n");
    exit(-1);
  }
  message_loop();

  close_connection(sock);
}

/* End Of File */
