/* cl_nn.h
 * ANDHILL (soccer client for Robocup97)
 * Tomohito Andou <andou@is.titech.ac.jp>
 * Tokyo Institute of Technology
 * Dept of Mathematical and Computing Sciences
 * Copyright (C) 1997 Tomohito Andou
 */

#ifndef CL_NN_H
#define CL_NN_H

#include "client.h"

#define SA_IN	(4)
#define SA_OU	(1)

#define PO_IN	(5)
#define PO_OU	(1)

extern double sa_i[SA_IN+1];
extern double sa_o[SA_OU];

extern double po_i[PO_IN+1];
extern double po_o[PO_OU];

double safety_exec(void);
double posi_exec(void);
void posi_backprop(double ratio, int k);
void posi_backprop_sp(double ratio, double rew, int k);
void posi_begin(void);
void posi_end(void);
void posi_init(void);
void posi_reward(double rew, int k);
void posi_rand_init(int flag);
void posi_output(FILE* fp);
void posi_input(FILE* fp);
double sigmoid(double x);

#endif

/* End Of File */
